;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Update the category itemcount field each time we add, change or delete MyInfo items or categories
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure UpdateCategoryItemCount(CategoryName.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  DatabaseQuery.s = "SELECT COUNT(Category) "
  
  DatabaseQuery.s + "AS totalrecs FROM MyInfo "
  
  DatabaseQuery.s + "WHERE Category = '"  + CategoryName.s + "'"
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If DatabaseQuery(Program\DatabaseHandle, DatabaseQuery.s) <> #DatabaseQueryFail
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    While NextDatabaseRow(Program\DatabaseHandle)
      
      CategoryCount.s = GetDatabaseString(Program\DatabaseHandle,  0)
      
    Wend
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    FinishDatabaseQuery(Program\DatabaseHandle)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    DatabaseUpdate.s  = "UPDATE Categories "
    
    DatabaseUpdate.s  + "SET Itemcount = '"   + CategoryCount.s   + "' "
    
    DatabaseUpdate.s  + "WHERE Category = '"  + CategoryName.s    + "'"
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If DatabaseUpdate(Program\DatabaseHandle, DatabaseUpdate.s) <> #DatabaseUpdateFail
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      CategoryListCount.i = CountGadgetItems(#Gadget_MyInfo_Category)
      
      ;--------------------------------------------------------------------------------------------
      ; Do we more than just the standard categories?
      ;--------------------------------------------------------------------------------------------
      
      If CategoryListCount.i > 7  
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        For FindCategoryInList.i = 7 To CategoryListCount.i -1
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          CategoryInList.s  = GetGadgetItemText(#Gadget_MyInfo_Category, FindCategoryInList.i, #CategoryTitleColumn)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          If FindString(CategoryInList.s, "(", 1) <> #NothingFound
            
            CategoryInList.s = Trim(StringField(CategoryInList.s, 1, "("))
            
            If CategoryInList.s = CategoryName.s
              
              SetGadgetItemText(#Gadget_MyInfo_Category, FindCategoryInList.i, CategoryInList.s  + " (" + CategoryCount.s + ")", #CategoryTitleColumn)
              
              SetGadgetItemText(#Gadget_MyInfo_Category, FindCategoryInList.i, CategoryCount.s,                                  #CategoryItemsColumn)
              
             ;SetGadgetItemText(#Gadget_MyInfo_Category, FindCategoryInList.i, IconName.s,                                       #CategoryIconColumn)   ; Name of the icon
              
             ;SetGadgetItemText(#Gadget_MyInfo_Category, FindCategoryInList.i, RecordNumber.s,                                   #CategoryRecordColumn) ; Record number of this category
              
            EndIf
            
          Else
            
            If CategoryInList.s = CategoryName.s
              
              SetGadgetItemText(#Gadget_MyInfo_Category, FindCategoryInList.i, CategoryInList.s  + " (" + CategoryCount.s + ")", #CategoryTitleColumn)
              
              SetGadgetItemText(#Gadget_MyInfo_Category, FindCategoryInList.i, CategoryCount.s,                                  #CategoryItemsColumn)
              
             ;SetGadgetItemText(#Gadget_MyInfo_Category, FindCategoryInList.i, IconName.s,                                       #CategoryIconColumn)   ; Name of the icon
              
             ;SetGadgetItemText(#Gadget_MyInfo_Category, FindCategoryInList.i, RecordNumber.s,                                   #CategoryRecordColumn) ; Record number of this category
              
            EndIf
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Next FindCategoryInList.i
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings", "Error", "Could not update the category itemcount", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Error", "Could not get a count of the categories for the category string", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 2
; FirstLine = 111
; Folding = -
; EnableAsm
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableUnicode