;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Copy highlighted data to the system clipboard
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure CopyDataToClipboard()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CurrentLine.i = GetGadgetState(#Gadget_MyInfo_Titles)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If CurrentLine.i <> #NoCurrentLine
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    pasDeleted.s = GetGadgetItemText(#Gadget_MyInfo_Titles, CurrentLine.i, #DeletedColumn)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If pasDeleted <> "1"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      passRecord.s = GetGadgetItemText(#Gadget_MyInfo_Titles, CurrentLine.i, #RecordColumn)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      QueryString.s             + 

      "SELECT * FROM MyInfo "   + 
      
      "WHERE Recordid = '"      + 

      passRecord.s + "' "       + 
      
      "AND Deleted <> '1'"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If DatabaseQuery(Program\DatabaseHandle, QueryString.s) <> #DatabaseQueryFail
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        While NextDatabaseRow(Program\DatabaseHandle)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          MasterString.s + FormatField("Title",             25) +  KillQuote(GetDatabaseString(Program\DatabaseHandle,  0))                + #CRLF$
          
          MasterString.s + #Empty$                                                                                                         + #CRLF$
          
          MasterString.s + FormatField("Information",       25) +  KillQuote(GetDatabaseString(Program\DatabaseHandle,  1))                + #CRLF$
          
          MasterString.s + #Empty$                                                                                                         + #CRLF$
          
          MasterString.s + FormatField("Category",          25) +            GetDatabaseString(Program\DatabaseHandle,  2)                 + #CRLF$
          
          MasterString.s + FormatField("Archived",          25) +            GetDatabaseString(Program\DatabaseHandle,  3)                 + #CRLF$
          
          MasterString.s + FormatField("Favourite",         25) +            GetDatabaseString(Program\DatabaseHandle,  4)                 + #CRLF$
          
          MasterString.s + FormatField("Locked",            25) +            GetDatabaseString(Program\DatabaseHandle,  5)                 + #CRLF$
          
          MasterString.s + FormatField("Deleted",           25) +            GetDatabaseString(Program\DatabaseHandle,  6)                 + #CRLF$
          
          MasterString.s + FormatField("Updated",           25) +    IsoDate(GetDatabaseString(Program\DatabaseHandle,  7), "NormalDate")  + #CRLF$
          
          MasterString.s + FormatField("Owner",             25) +            GetDatabaseString(Program\DatabaseHandle,  8)                 + #CRLF$
          
          MasterString.s + FormatField("Attachments",       25) +            GetDatabaseString(Program\DatabaseHandle,  9)                 + #CRLF$
          
          MasterString.s + FormatField("Recordid",          25) +            GetDatabaseString(Program\DatabaseHandle, 10)                 + #CRLF$
          
          MasterString.s + #Empty$                                                                                                         + #CRLF$
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Wend
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        FinishDatabaseQuery(Program\DatabaseHandle)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings", "Warn", "The database query failed or was empty. " + DatabaseError(), #PB_Compiler_Procedure)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetClipboardText(MasterString.s)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetInfoBarArea("Headings", "Info", Str(CopyCounter.i) + "The selected item was copied to the clipboard", #PB_Compiler_Procedure)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings", "Warn", "Cannot copy a deleted item, undelete it first.", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Info", "No current line selected to be copied.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 156
; FirstLine = 111
; Folding = -
; EnableXP
; HideErrorLog
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableExeConstant