;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Show the data string for MyInfo on the screen
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure ShowMyInfoData()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CurrentLine.i = GetGadgetState(#Gadget_MyInfo_Titles)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If CurrentLine.i <> #NoCurrentLine
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    passDeleted.s   = GetGadgetItemText(#Gadget_MyInfo_Titles, CurrentLine.i, #DeletedColumn)
    
    passRecord.s    = GetGadgetItemText(#Gadget_MyInfo_Titles, CurrentLine.i, #RecordColumn)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If passDeleted.s <> "1"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If passRecord.s <> #Empty$
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        QueryString.s           + 

        "SELECT * FROM MyInfo " + 
        
        "WHERE Recordid = '"    + 

        passRecord.s + "'"
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If DatabaseQuery(Program\DatabaseHandle,  QueryString.s)  <> #DatabaseQueryFail
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          While NextDatabaseRow(Program\DatabaseHandle)
            
            passTitle.s         = KillQuote(GetDatabaseString(Program\DatabaseHandle,  0))                 ;
            
            passInformation.s   = KillQuote(GetDatabaseString(Program\DatabaseHandle,  1))                 ;
            
            passCategory.s      = KillQuote(GetDatabaseString(Program\DatabaseHandle,  2))                 ;
            
            passArchived.s      =           GetDatabaseString(Program\DatabaseHandle,  3)                  ;
            
            passFavourite.s     =           GetDatabaseString(Program\DatabaseHandle,  4)                  ;
            
            passLocked.s        =           GetDatabaseString(Program\DatabaseHandle,  5)                  ;
            
            passDeleted.s       =           GetDatabaseString(Program\DatabaseHandle,  6)                  ;
            
            passUpdated.s       =   IsoDate(GetDatabaseString(Program\DatabaseHandle,  7), "NormalDate")   ;
            
            passOwner.s         =           GetDatabaseString(Program\DatabaseHandle,  8)                  ;
            
            passAttachments.s   =           GetDatabaseString(Program\DatabaseHandle,  9)                  ;
            
            passRecord.s        =           GetDatabaseString(Program\DatabaseHandle, 10)                  ;
            
          Wend
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          ;           If  passFavourite.s = "1"
          ;             SetGadgetColor(#Gadget_MyInfo_Information, #PB_Gadget_BackColor, $D5F8FD)
          ;           ElseIf passDeleted.s = "1"
          ;             SetGadgetColor(#Gadget_MyInfo_Information, #PB_Gadget_BackColor, $E5D8FC)
          ;           ElseIf  passArchived.s = "1"
          ;             SetGadgetColor(#Gadget_MyInfo_Information, #PB_Gadget_BackColor, $FED9D6)
          ;           ElseIf  passLocked.s = "1"
          ;             SetGadgetColor(#Gadget_MyInfo_Information, #PB_Gadget_BackColor, $FDD0CC)
          ;           Else
          ;             SetGadgetColor(#Gadget_MyInfo_Information, #PB_Gadget_BackColor, $D7FDDA)
          ;           EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          If Toggle\HideDetail = #False
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            SetGadgetText(#Gadget_MyInfo_Information, passInformation.s)
            
            If  passFavourite.s = "1"
              
              Status.s = "Favourite"
              
            ElseIf passDeleted.s = "1"
              
              Status.s = "Deleted"
              
            ElseIf  passArchived.s = "1"
              
              Status.s = "Archived"
              
            ElseIf  passLocked.s = "1"
              
              Status.s = "Locked"
              
            Else
              
              Status.s = "Normal"
              
            EndIf
            
            If passTitle.s <> #Empty$
              
              SetGadgetItemText(#Gadget_MyInfo_Titles, #ListIconHeadingArea, "Title:  " + passTitle.s, 0)
              
              AddGadgetItem(#Gadget_MyInfo_Information, #FirstItem, "Category:  [" + Queue\CurrentCategory.s + "], Record: ["  + passRecord.s +  "], Status:  [" + Status.s + "]")
              
              AddGadgetItem(#Gadget_MyInfo_Information, 1, #Empty$)
              
              SetInfoBarArea("Headings",  "Info",  "Title >> [" + passTitle.s + "], Category >> [" + Queue\CurrentCategory.s + "]", #PB_Compiler_Procedure)
              
            Else
              
              SetGadgetItemText(#Gadget_MyInfo_Titles, #ListIconHeadingArea, "Title:  None?, [", 0)
              
              AddGadgetItem(#Gadget_MyInfo_Information, #FirstItem, "Category:  [" + Queue\CurrentCategory.s + "], Record: ["  + passRecord.s +  "], Status:  [" + Status.s + "]")
              
              AddGadgetItem(#Gadget_MyInfo_Information, 1, #Empty$)
              
              SetInfoBarArea("Headings",  "Info",  "Title >> [Empty title], Category >> [" + Queue\CurrentCategory.s + "]", #PB_Compiler_Procedure)
              
            EndIf
          
            SetInfoBarArea("Number",  #Empty$, passRecord.s, #PB_Compiler_Procedure)
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
          ElseIf Toggle\HideDetail = #True
            
            SetGadgetText(#Gadget_MyInfo_Information, MakeString(Len(passInformation.s), "*"))
            
            AddGadgetItem(#Gadget_MyInfo_Information, #FirstItem, "The data is currently hidden. Press Shortcut keys ["  + GetShortcutText(#ShortcutValue_HideDetail)  + "] to change.")
            
            AddGadgetItem(#Gadget_MyInfo_Information, 1, #Empty$)
            
            If passTitle.s <> #Empty$
              
              SetGadgetItemText(#Gadget_MyInfo_Titles, #ListIconHeadingArea, passTitle.s, 0)
              
              SetInfoBarArea("Headings",  "Info",  "Title >> [" + passTitle.s + "], Category >> [" + Queue\CurrentCategory.s + "]", #PB_Compiler_Procedure)
              
            Else
              
              SetGadgetItemText(#Gadget_MyInfo_Titles, #ListIconHeadingArea, "Title:  None?", 0)
              
              SetInfoBarArea("Headings",  "Info",  "Title >> [Empty title], Category >> [" + Queue\CurrentCategory.s + "]", #PB_Compiler_Procedure)
              
            EndIf
          
            SetInfoBarArea("Number",  #Empty$, passRecord.s, #PB_Compiler_Procedure)
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          FinishDatabaseQuery(Program\DatabaseHandle)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else

          SetInfoBarArea("Headings",  "Error",  "The database query has failed or was empty. " + DatabaseError(), #PB_Compiler_Procedure)
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings",  "Error",  "There was no record number found for the selected line.", #PB_Compiler_Procedure)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetGadgetText(#Gadget_MyInfo_Information, #Empty$)
      
      SetInfoBarArea("Headings",  "Warn",  "Cannot edit a deleted record, recover it first.", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Info",  "There is no current line selected.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 49
; FirstLine = 41
; Folding = -
; EnableXP
; HideErrorLog
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableExeConstant