﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Need a unicode aware version of the API directory creator
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure.s MakeSureDirectoryPathExists(Directory.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected Message.s
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

  ErrorCode.i = SHCreateDirectory(#Null, Directory.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Select ErrorCode.i

    Case #ERROR_SUCCESS               : Message.s = "Directory created"                            ; ResultCode = 0
    
    Case #ERROR_BAD_PATHNAME          : Message.s = "Bad directory path"                           ; ResultCode = 161
    
    Case #ERROR_FILENAME_EXCED_RANGE  : Message.s = "Directory path too long"                      ; ResultCode = 206

    Case #ERROR_FILE_EXISTS           : Message.s = "Directory already exists"                     ; ResultCode = 80
    
    Case #ERROR_ALREADY_EXISTS        : Message.s = "Directory already exists"                     ; ResultCode = 183
    
   ;Case #ERROR_CANCELLED             : Message.s = "User cancelled creation"                       ; ResultCode = ??. Not defined in compiler residents
    
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

  ProcedureReturn Message.s
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ; MakeSureDirectoryPathExists("c:\1\2\3\4\5\6")
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

EndProcedure

; Messages("dircreated")    = "The directory has been successfully created"
; Messages("baddirectory")  = "The directory specified has bad characters in the name"
; Messages("dirtoolong")    = "The directory path is far too long"
; Messages("direxists")     = "The directory path already exists"
; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 61
; FirstLine = 18
; Folding = -
; EnableAsm
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableUnicode