;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; First letter uppercase in a string box. srod!
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure MixedStringCase(Gadget.i)
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  Protected Parent, StringOut.s, StringIn.s, Temporary.s, Position, StartSelection, EndSelection
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  StringIn.s = GetGadgetText(Gadget.i)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If StringIn.s = #Empty$
    
    ProcedureReturn
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  WordFlag = #True
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SendMessage_(GadgetID(Gadget.i), #EM_GETSEL, @StartSelection, @EndSelection)  ; Get the Position of the caret.
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If StartSelection <> EndSelection
    
    ProcedureReturn
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Repeat
    
    Position + 1
    
    StringOut.s = Mid(StringIn.s, Position, 1)
    
    If WordFlag
      
      Temporary.s + UCase(StringOut.s)
      
    Else
      
      Temporary.s + StringOut.s
      
    EndIf
    
    If StringOut.s = Space(1)
      
      WordFlag = #True
      
    Else
      
      WordFlag = #False
      
    EndIf
    
  Until Position = Len(StringIn.s)
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  SetGadgetText(Gadget.i, Temporary.s)
  
  ;------------------------------------------------------------------------------------------------
  ; Return the caret to it's original Position
  ;------------------------------------------------------------------------------------------------
  
  SendMessage_(GadgetID(Gadget.i), #EM_SETSEL, EndSelection, EndSelection)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 88
; FirstLine = 54
; Folding = -
; DisableDebugger
; HideErrorLog
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0