﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Alias the Search type text to SQLite operators
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure.s SetSearchQuery(SearchOperator.s, SearchString.s)

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

  Select SearchOperator.s

    Case "Equal to"                 : SqlQueryString.s = " = '"      + SearchString.s + "'"

    Case "Does not equal"           : SqlQueryString.s = " <> '"     + SearchString.s + "'"

    Case "Greater than"             : SqlQueryString.s = " > '"      + SearchString.s + "'"

    Case "Greater than or equal to" : SqlQueryString.s = " >= '"     + SearchString.s + "'"

    Case "Less than"                : SqlQueryString.s = " < '"      + SearchString.s + "'"

    Case "Less than or equal to"    : SqlQueryString.s = " <= '"     + SearchString.s + "'"

    Case "Starts with"              : SqlQueryString.s = " LIKE '"   + SearchString.s + "%'"

    Case "Ends with"                : SqlQueryString.s = " LIKE '%"  + SearchString.s + "'"

    Case "Sounds like"              : SqlQueryString.s = " LIKE '%"  + SearchString.s + "%'"

  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

  ProcedureReturn SqlQueryString.s
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

EndProcedure


; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 38
; FirstLine = 3
; Folding = -
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0