﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Change the current read only state of the current help page
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure EditHelp()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CurrentEditMode.i = GetGadgetAttribute(#Gadget_Help_Help, #PB_Editor_ReadOnly)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If CurrentEditMode.i = #False      ; 0 = Editable and False = 0, this is backwards!
    
    Program\CurrentHelpFileEditMode = #True
    
    SetGadgetColor(#Gadget_Help_Help, #PB_Gadget_BackColor,  $F2F2F2)  ; Read only mode colour
    
    ModeMessage.s = "Read Only: " + GetFilePart(Program\CurrentHelpFileName)
    
  ElseIf CurrentEditMode.i = #True
    
    Program\CurrentHelpFileEditMode = #False
    
    SetGadgetColor(#Gadget_Help_Help, #PB_Gadget_BackColor,  $FFFFFF)  ; Edit mode colour
    
    ModeMessage.s = "Edit mode: " + GetFilePart(Program\CurrentHelpFileName)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SetGadgetAttribute(#Gadget_Help_Help, #PB_Editor_ReadOnly, Program\CurrentHelpFileEditMode)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SetGadgetText(#Gadget_Help_EditMode, ModeMessage.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 6
; Folding = -
; EnableAsm
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableUnicode