﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Find the last record number in the database, not necessarily the last record though due to deletions (fang)
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure.s LastRecord(TableName.s, TableField.s)

  ;------------------------------------------------------------------------------------------------
  ; Always create long winded queries for readability
  ;------------------------------------------------------------------------------------------------
  
  QueryString.s           + 

  "SELECT MAX("           + 

  TableField.s            + 

  ") As LASTREC FROM "    + 

  TableName.s             + 

  #Empty$
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If DatabaseQuery(Program\DatabaseHandle, QueryString.s) <> #DatabaseQueryFail
    
    While NextDatabaseRow(Program\DatabaseHandle)
    
      LastRecord.s = GetDatabaseString(Program\DatabaseHandle,  0)
      
    Wend
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    FinishDatabaseQuery(Program\DatabaseHandle)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ProcedureReturn LastRecord.s
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------

  Else
    
    SetInfoBarArea("Headings",  "Error", "Failed To get the last record inserted. " + DatabaseError(), #PB_Compiler_Procedure)
    
  EndIf  

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 20
; FirstLine = 21
; Folding = -
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0