﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Enable importing data by dropping a text file
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure DragnewData()
  
  ; Grab the filenames passed in the dropped list of files
  
  FileNameString.s = EventDropFiles()
  
  ; 
  
  If FileNameString.s <> #Empty$
    
    ; 
    
    If FindString(EventDropFiles(), #LF$, 1) = 0
      
      ; 
      
      If FileSize(FileNameString.s) <> -1 And FileSize(FileNameString.s) <> -2
        
        ; 
        
        FileTypeCheck.s = GetExtensionPart(FileNameString.s)
        
        ; 
        
        CategoryCheck.s = GetPathPart(FileNameString.s)
        
        ; 
        
        Select FileTypeCheck.s
            
            ; 
            
          Case  "txt"
            
            ; 
            
            FileNameHandle.i = ReadFile(#PB_Any, FileNameString.s)
            
            ; 
            
            If FileNameHandle.i <> 0
              
              ; 
              
              While Eof(FileNameHandle.i) = 0
                
                ; 
                
                StringToProcess.s = ReadString(FileNameHandle.i, #PB_File_IgnoreEOL)
                
                ; 
                
              Wend
              
              ; 
              
              CloseFile(FileNameHandle.i)
              
              ; 
              
              If StringToProcess.s
                
                ; 
                
                AddNewData()
                
                ; 
                
                SetGadgetText(#Gadget_Data_Title,     StringField(StringToProcess.s, 1, "//"))
                
                SetGadgetText(#Gadget_Data_Details,   StringField(StringToProcess.s, 2, "//"))
                
               ;SetGadgetText(#Gadget_Data_cCategory, StringField(StringToProcess.s, 3, "//"))
                
               ;SetGadgetText(#Gadget_Data_Owner,     StringField(StringToProcess.s, 4, "//"))
                
                ; 
                
              Else
                
                ; 
                
                Debug "There was nothing in the string that was just read from the file"
                
                ; 
                
              EndIf
              
              ; 
              
            Else
              
              ; 
              
              Debug "Did not get a file handle, so file wasn't opened"
              
              ; 
              
            EndIf
            
            ; 
            
        EndSelect
        
        ; 
        
      Else
        
        ; 
        
        Debug "The file wasn't found or the user dragged a directory"
        
        ; 
        
      EndIf
      
      ; 
      
    Else
      
      ; 
      
      Debug "More than one filename was dropped so we handle things differently"
      
      ; 
      
    EndIf
    
    ; 
    
  Else
    
    ; 
    
    Debug "Nothing to so as the user failed to drop any document."
    
    ; 
    
  EndIf
  
  ; 
  
EndProcedure


; IDE Options = PureBasic 5.62 (Windows - x86)
; Folding = -
; EnableAsm
; EnableThread
; EnableXP
; EnableOnError
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableExeConstant