;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Turn time updating on in the title bar
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure ToggleTitleBarClock()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected Message.s, UpdateString.s
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  If Toggle\TitleClock = #True
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    Toggle\TitleClock = #False
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    KillTimer_(WindowID(#Window_MyInfo), #TitleBarClockTimer)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetWindowTitle(#Window_MyInfo, 

    #Fish                                             + 

    #Basename                                         + 

    #Version                                          + 

    Program\CompileCounters                           + 

    ",  [Keyboard shortcuts list:   "                 + 

    GetShortCutText(#ShortcutValue_KeyboardShortcuts) + 

    ",  Exit program list:  "                         + 

    GetShortCutText(#ShortcutValue_ExitProgram)       + 
    
    "]")
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    SetInfoBarArea("Headings", "Info", "The titlebar clock is now switched off.", #PB_Compiler_Procedure)
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
  ElseIf Toggle\TitleClock = #False
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    Toggle\TitleClock = #True
    
    ;----------------------------------------------------------------------------------------------
    ; Create the permanent timer
    ;----------------------------------------------------------------------------------------------
    
    SetTimer_(WindowID(#Window_MyInfo), #TitleBarClockTimer, 1000, @TitleBarClock())    ; 1000 = 1 second
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    SetInfoBarArea("Headings", "Info",  "The titlebar clock is now switched on.", #PB_Compiler_Procedure)
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SetMenuItemState(#MenuBar_MyInfo,     #MenuBar_MyInfo_TitleClock,     Toggle\TitleClock)
  
  SetMenuItemState(#PopMenuBar_MyInfo,  #PopMenuBar_MyInfo_TitleClock,  Toggle\TitleClock)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  UpdateString.s          +

  "UPDATE Preferences "   + 
  
  "SET TitleClock = '"    + 

  Str(Toggle\TitleClock)  + 

  "' "                    + 
  
  "WHERE Recordid = '1'"
  
  If DatabaseUpdate(Program\DatabaseHandle, UpdateString.s) <>  #DatabaseUpdateFail
    
    SetInfoBarArea("Headings", "Info",  "The titlebar clock setting was saved", #PB_Compiler_Procedure)
    
  Else
    
    SetInfoBarArea("Headings", "Info",  "The titlebar clock setting was not saved:  " + DatabaseError(), #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

;  SetTimer_(WindowID(#Window_MyInfo), #TitleBarClockTimer, 1000, @TitleBarClock())    ; 1000 = 1 second
; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 98
; FirstLine = 81
; Folding = -
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableExeConstant