;==========================================================================================================================
; Check the startup unlocking password
;==========================================================================================================================

Procedure CheckStartPassWord()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

  If IsWindow(#Window_StartPass)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
  
    StoredPassWord.s = GetIniVal("Program Options", "MD5 FingerPrint")
    
    NewPassWord.s    = GetGadgetText(#Gadget_StartPass_UnlockPassWord)
  
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
  
    If NewPassWord.s = ""
   
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
  
      MessageRequester("Security Error",  "The password field must not be empty." + Chr(10) + Chr(13) + Chr(10) + Chr(13) + "You have to type in a password to unlock the program."  + Chr(10) + Chr(13) + Chr(10) + Chr(13) +  "Try again.",  #MB_ICONWARNING)
  
      SetGadgetText(#Gadget_StartPass_UnlockPassWord, "")
  
      SetActiveGadget(#Gadget_StartPass_UnlockPassWord)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
    
    ElseIf NewPassWord.s <> ""
    
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
    
      NewPassWord.s    = MD5Fingerprint(@NewPassWord,  Len(NewPassWord.s))
  
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
  
      If NewPassWord.s <> StoredPassWord.s
  
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
  
        MessageRequester("Security Error",  "The passwords do not match." + Chr(10) + Chr(13) + Chr(10) + Chr(13) + "Try again.",  #MB_ICONWARNING)
    
        SetGadgetText(#Gadget_StartPass_UnlockPassWord, "")
    
        SetActiveGadget(#Gadget_StartPass_UnlockPassWord)
  
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
  
      ElseIf  NewPassWord.s = StoredPassWord.s
  
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
  
        Program\QuitValue = 1
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
  
    EndIf
  
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  EndProcedure


; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 1
; EnableXP