;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Check if more than once instance of a program is running
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

ProcedureDLL.l Instance_Running(LockString.s)
  
  *MyMutex = CreateMutex_(#Null, 1, LockString.s)
  
  If *MyMutex <> 0 And GetLastError_() = #ERROR_ALREADY_EXISTS
    
    CloseHandle_(*MyMutex)
    
    ProcedureReturn #True
    
  Else
    
    ProcedureReturn #False
    
  EndIf
  
EndProcedure

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Check for executable being renamed
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

; RunningFileName.s = GetFilePart(ProgramFilename())
; 
; VersionFileName.s = VersionFileName.s
; 
; If RunningFileName.s <> VersionFileName.s
;   
;   ErrorMessage.s = "Illegally renamed executable file,"  + #CRLF$
;   
;   ErrorMessage.s + "It must be called: " + VersionFileName.s
; 
;   MessageRequester("Program name changed", ErrorMessage.s,  #MB_ICONWARNING)
;   
;   End
;   
; EndIf

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; ; Check for executable being renamed
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; 
; If Instance_Running(VersionFileName.s)
;   
;   StickyWindow(#Window_MyInfo, #True)
;   
;   ErrorMessage.s = VersionFileName.s + " is already running."  + #CRLF$
;   
;   ErrorMessage.s + "Cannot start another instance!"
; 
;   MessageRequester("Program already running", ErrorMessage.s,  #MB_ICONWARNING)
;   
;   End
;   
; EndIf


; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 20
; FirstLine = 23
; Folding = -
; EnableAsm
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableUnicode